
/* listmkt.c v.0.3.6a (c) 2015 Ilya V. Vasilyev */

#include <stdio.h>
#include <stdlib.h>

static const char *alRusUp[] =
{ "А", "Б", "В", "Г", "Д", "Е", "Ж", "З",
  "И", "Й", "К", "Л", "М", "Н", "О", "П",
  "Р", "С", "Т", "У", "Ф", "Х", "Ц", "Ч",
  "Ш", "Щ", "Ъ", "Ы", "Ь", "Э", "Ю", "Я", 0
}, *alRusL1[] =
{ "а", "б", "в", "г", "д", "е", "ж", "з",
  "и", "й", "к", "л", "м", "н", "о", "п", 0
}, *alRusL2[] =
{ "р", "с", "т", "у", "ф", "х", "ц", "ч",
  "ш", "щ", "ъ", "ы", "ь", "э", "ю", "я", 0
}, *alRusYo[] =
{ "Ё", "ё", 0
}, *alSpec[] =
{ "÷", "≥", "≠", "×", "↵", "↻", 0,   "↔",
  0,   "π", 0,   0,   0,   "²", "ˣ", "ʸ",
  "↵", "↤", "⇤", "⇥", "←", "→", "↑", "↓",
  "↖", "↘", "↔", 0,   0,   0,   0,   0
};

static const char nbsp[] = " ";
static unsigned char line[64];

void PutChar(int c, int c0)
{ if ((c>=0x20) && (c<0x80))
  switch (c)
  { case 0x20: printf("%s", nbsp);  break;
    case 0x27: printf("%s", "’");   break;
    case 0x2a: printf("%s", "∗");   break;
    case 0x2d: printf("%s", "−");   break;
    case 0x7f: printf("%s", "⌂");   break;
    default:  putchar(c);
  } else if ((c>=0x80) && (c<=0x9f)) printf("%s", alRusUp[c-0x80]);
  else if ((c>=0xa0) && (c<=0xaf)) printf("%s", alRusL1[c-0xa0]);
  else if ((c>=0xb0) && (c<=0xcf))
  { if (alSpec[c-0xb0]) printf("%s", alSpec[c-0xb0]);
    else if (c0) putchar(c0);
  } else if ((c>=0xe0) && (c<=0xef)) printf("%s", alRusL2[c-0xe0]);
  else switch (c)
  { case 0x00: printf("%s", "▌");         break;
    case 0x10: printf("%s", "►");         break;
    case 0x13: printf("%s", "");         break;
    case 0x18: printf("%s", "↑");         break;
    case 0x19: printf("%s", "↓");         break;
    case 0x1a: printf("%s", "→");         break;
    case 0x1b: printf("%s", "←");         break;
    case 0x1f: printf("%s", nbsp);        break;
    case 0xf0: printf("%s", alRusYo[0]);  break;
    case 0xf1: printf("%s", alRusYo[1]);  break;
    case 0xfb: printf("%s", "√");         break;
    default: if (c0) putchar(c0);
  }
}


int length(void)
/* -TRAILING */
{ int i=64;
  while(i>0)
    if (line[i-1]!=32) return i;
    else --i;
  return 0;
}


int main(int arc, char *argv[])
{ FILE *f = fopen(argv[1],"rb");
  int ln,i;
  printf("listmkt v0.3.6a (c) AtH, 19 апреля 2015, Файл: %s\n",argv[1]);
  if (f!=NULL)
  { for(ln=0; ln<48; ln++)
    { size_t n = fread(line,1,64,f);
      int im = length();
      if (ln<10) printf("%s%s%d%s", nbsp, nbsp, ln, nbsp);
      else printf("%s%d%s", nbsp, ln, nbsp);
      if ((n!=64) || ferror(f))
      { printf("Ошибка чтения\n");
        fclose(f);
        return 0;
      } else for(i=0; i<im; i++) PutChar(line[i],'.');
      printf("\n");
    }
    fclose(f);
  } else printf(
  "Не найден файл '%s'.\n"
  "Использование: listmkt имя-файла\n",argv[1]);
}

